#if (__LSB_VERSION__ >= 31 )
#ifndef _GTK_2_0_GTK_GTKENUMS_H_
#define _GTK_2_0_GTK_GTKENUMS_H_


#ifdef __cplusplus
extern "C" {
#endif


    typedef enum {
	GTK_STATE_NORMAL = 0,
	GTK_STATE_ACTIVE = 1,
	GTK_STATE_PRELIGHT = 2,
	GTK_STATE_SELECTED = 3,
	GTK_STATE_INSENSITIVE = 4
    } GtkStateType;

    typedef enum {
	GTK_SORT_ASCENDING = 0,
	GTK_SORT_DESCENDING = 1
    } GtkSortType;

    typedef enum {
	GTK_UPDATE_CONTINUOUS = 0,
	GTK_UPDATE_DISCONTINUOUS = 1,
	GTK_UPDATE_DELAYED = 2
    } GtkUpdateType;

    typedef enum {
	GTK_ORIENTATION_HORIZONTAL = 0,
	GTK_ORIENTATION_VERTICAL = 1
    } GtkOrientation;

    typedef enum {
	GTK_BUTTONBOX_DEFAULT_STYLE = 0,
	GTK_BUTTONBOX_SPREAD = 1,
	GTK_BUTTONBOX_EDGE = 2,
	GTK_BUTTONBOX_START = 3,
	GTK_BUTTONBOX_END = 4
    } GtkButtonBoxStyle;

    typedef enum {
	GTK_JUSTIFY_LEFT = 0,
	GTK_JUSTIFY_RIGHT = 1,
	GTK_JUSTIFY_CENTER = 2,
	GTK_JUSTIFY_FILL = 3
    } GtkJustification;

    typedef enum {
	GTK_TEXT_DIR_NONE = 0,
	GTK_TEXT_DIR_LTR = 1,
	GTK_TEXT_DIR_RTL = 2
    } GtkTextDirection;

    typedef enum {
	GTK_WRAP_NONE = 0,
	GTK_WRAP_CHAR = 1,
	GTK_WRAP_WORD = 2,
	GTK_WRAP_WORD_CHAR = 3
    } GtkWrapMode;

    typedef enum {
	GTK_CURVE_TYPE_LINEAR = 0,
	GTK_CURVE_TYPE_SPLINE = 1,
	GTK_CURVE_TYPE_FREE = 2
    } GtkCurveType;

    typedef enum {
	GTK_PACK_START = 0,
	GTK_PACK_END = 1
    } GtkPackType;

    typedef enum {
	GTK_ARROW_UP = 0,
	GTK_ARROW_DOWN = 1,
	GTK_ARROW_LEFT = 2,
	GTK_ARROW_RIGHT = 3
    } GtkArrowType;

    typedef enum {
	GTK_SHADOW_NONE = 0,
	GTK_SHADOW_IN = 1,
	GTK_SHADOW_OUT = 2,
	GTK_SHADOW_ETCHED_IN = 3,
	GTK_SHADOW_ETCHED_OUT = 4
    } GtkShadowType;

    typedef enum {
	GTK_DIR_TAB_FORWARD = 0,
	GTK_DIR_TAB_BACKWARD = 1,
	GTK_DIR_UP = 2,
	GTK_DIR_DOWN = 3,
	GTK_DIR_LEFT = 4,
	GTK_DIR_RIGHT = 5
    } GtkDirectionType;

    typedef enum {
	GTK_ICON_SIZE_INVALID = 0,
	GTK_ICON_SIZE_MENU = 1,
	GTK_ICON_SIZE_SMALL_TOOLBAR = 2,
	GTK_ICON_SIZE_LARGE_TOOLBAR = 3,
	GTK_ICON_SIZE_BUTTON = 4,
	GTK_ICON_SIZE_DND = 5,
	GTK_ICON_SIZE_DIALOG = 6
    } GtkIconSize;

    typedef enum {
	GTK_SELECTION_NONE = 0,
	GTK_SELECTION_SINGLE = 1,
	GTK_SELECTION_BROWSE = 2,
	GTK_SELECTION_MULTIPLE = 3,
	GTK_SELECTION_EXTENDED = 3
    } GtkSelectionMode;

    typedef enum {
	GTK_CORNER_TOP_LEFT = 0,
	GTK_CORNER_BOTTOM_LEFT = 1,
	GTK_CORNER_TOP_RIGHT = 2,
	GTK_CORNER_BOTTOM_RIGHT = 3
    } GtkCornerType;

    typedef enum {
	GTK_POS_LEFT = 0,
	GTK_POS_RIGHT = 1,
	GTK_POS_TOP = 2,
	GTK_POS_BOTTOM = 3
    } GtkPositionType;

    typedef enum {
	GTK_TOOLBAR_ICONS = 0,
	GTK_TOOLBAR_TEXT = 1,
	GTK_TOOLBAR_BOTH = 2,
	GTK_TOOLBAR_BOTH_HORIZ = 3
    } GtkToolbarStyle;

    typedef enum {
	GTK_RELIEF_NORMAL = 0,
	GTK_RELIEF_HALF = 1,
	GTK_RELIEF_NONE = 2
    } GtkReliefStyle;

    typedef enum {
	GTK_PIXELS = 0,
	GTK_INCHES = 1,
	GTK_CENTIMETERS = 2
    } GtkMetricType;

    typedef enum {
	GTK_EXPAND = 1,
	GTK_SHRINK = 2,
	GTK_FILL = 4
    } GtkAttachOptions;

    typedef enum {
	GTK_MESSAGE_INFO = 0,
	GTK_MESSAGE_WARNING = 1,
	GTK_MESSAGE_QUESTION = 2,
	GTK_MESSAGE_ERROR = 3
    } GtkMessageType;

    typedef enum {
	GTK_POLICY_ALWAYS = 0,
	GTK_POLICY_AUTOMATIC = 1,
	GTK_POLICY_NEVER = 2
    } GtkPolicyType;

    typedef enum {
	GTK_RESIZE_PARENT = 0,
	GTK_RESIZE_QUEUE = 1,
	GTK_RESIZE_IMMEDIATE = 2
    } GtkResizeMode;

    typedef enum {
	GTK_WINDOW_TOPLEVEL = 0,
	GTK_WINDOW_POPUP = 1
    } GtkWindowType;

    typedef enum {
	GTK_WIN_POS_NONE = 0,
	GTK_WIN_POS_CENTER = 1,
	GTK_WIN_POS_MOUSE = 2,
	GTK_WIN_POS_CENTER_ALWAYS = 3,
	GTK_WIN_POS_CENTER_ON_PARENT = 4
    } GtkWindowPosition;

    typedef enum {
	GTK_EXPANDER_COLLAPSED = 0,
	GTK_EXPANDER_SEMI_COLLAPSED = 1,
	GTK_EXPANDER_SEMI_EXPANDED = 2,
	GTK_EXPANDER_EXPANDED = 3
    } GtkExpanderStyle;

    typedef enum {
	GTK_PATH_PRIO_LOWEST = 0,
	GTK_PATH_PRIO_GTK = 4,
	GTK_PATH_PRIO_APPLICATION = 8,
	GTK_PATH_PRIO_THEME = 10,
	GTK_PATH_PRIO_RC = 12,
	GTK_PATH_PRIO_HIGHEST = 15
    } GtkPathPriorityType;

    typedef enum {
	GTK_PATH_WIDGET = 0,
	GTK_PATH_WIDGET_CLASS = 1,
	GTK_PATH_CLASS = 2
    } GtkPathType;

    typedef enum {
	GTK_SCROLL_NONE = 0,
	GTK_SCROLL_JUMP = 1,
	GTK_SCROLL_STEP_BACKWARD = 2,
	GTK_SCROLL_STEP_FORWARD = 3,
	GTK_SCROLL_PAGE_BACKWARD = 4,
	GTK_SCROLL_PAGE_FORWARD = 5,
	GTK_SCROLL_STEP_UP = 6,
	GTK_SCROLL_STEP_DOWN = 7,
	GTK_SCROLL_PAGE_UP = 8,
	GTK_SCROLL_PAGE_DOWN = 9,
	GTK_SCROLL_STEP_LEFT = 10,
	GTK_SCROLL_STEP_RIGHT = 11,
	GTK_SCROLL_PAGE_LEFT = 12,
	GTK_SCROLL_PAGE_RIGHT = 13,
	GTK_SCROLL_START = 14,
	GTK_SCROLL_END = 15
    } GtkScrollType;

    typedef enum {
	GTK_MOVEMENT_LOGICAL_POSITIONS = 0,
	GTK_MOVEMENT_VISUAL_POSITIONS = 1,
	GTK_MOVEMENT_WORDS = 2,
	GTK_MOVEMENT_DISPLAY_LINES = 3,
	GTK_MOVEMENT_DISPLAY_LINE_ENDS = 4,
	GTK_MOVEMENT_PARAGRAPHS = 5,
	GTK_MOVEMENT_PARAGRAPH_ENDS = 6,
	GTK_MOVEMENT_PAGES = 7,
	GTK_MOVEMENT_BUFFER_ENDS = 8,
	GTK_MOVEMENT_HORIZONTAL_PAGES = 9
    } GtkMovementStep;

    typedef enum {
	GTK_MENU_DIR_PARENT = 0,
	GTK_MENU_DIR_CHILD = 1,
	GTK_MENU_DIR_NEXT = 2,
	GTK_MENU_DIR_PREV = 3
    } GtkMenuDirectionType;

    typedef enum {
	GTK_SCROLL_STEPS = 0,
	GTK_SCROLL_PAGES = 1,
	GTK_SCROLL_ENDS = 2,
	GTK_SCROLL_HORIZONTAL_STEPS = 3,
	GTK_SCROLL_HORIZONTAL_PAGES = 4,
	GTK_SCROLL_HORIZONTAL_ENDS = 5
    } GtkScrollStep;

    typedef enum {
	GTK_DELETE_CHARS = 0,
	GTK_DELETE_WORD_ENDS = 1,
	GTK_DELETE_WORDS = 2,
	GTK_DELETE_DISPLAY_LINES = 3,
	GTK_DELETE_DISPLAY_LINE_ENDS = 4,
	GTK_DELETE_PARAGRAPH_ENDS = 5,
	GTK_DELETE_PARAGRAPHS = 6,
	GTK_DELETE_WHITESPACE = 7
    } GtkDeleteType;

    typedef enum {
	GTK_VISIBILITY_NONE = 0,
	GTK_VISIBILITY_PARTIAL = 1,
	GTK_VISIBILITY_FULL = 2
    } GtkVisibility;

    typedef enum {
	GTK_IM_PREEDIT_NOTHING,
	GTK_IM_PREEDIT_CALLBACK,
	GTK_IM_PREEDIT_NONE
    } GtkIMPreeditStyle;

    typedef enum {
	GTK_ANCHOR_CENTER,
	GTK_ANCHOR_NORTH,
	GTK_ANCHOR_NORTH_WEST,
	GTK_ANCHOR_NORTH_EAST,
	GTK_ANCHOR_SOUTH,
	GTK_ANCHOR_SOUTH_WEST,
	GTK_ANCHOR_SOUTH_EAST,
	GTK_ANCHOR_WEST,
	GTK_ANCHOR_EAST,
	GTK_ANCHOR_N = GTK_ANCHOR_NORTH,
	GTK_ANCHOR_NW = GTK_ANCHOR_NORTH_WEST,
	GTK_ANCHOR_NE = GTK_ANCHOR_NORTH_EAST,
	GTK_ANCHOR_S = GTK_ANCHOR_SOUTH,
	GTK_ANCHOR_SW = GTK_ANCHOR_SOUTH_WEST,
	GTK_ANCHOR_SE = GTK_ANCHOR_SOUTH_EAST,
	GTK_ANCHOR_W = GTK_ANCHOR_WEST,
	GTK_ANCHOR_E = GTK_ANCHOR_EAST
    } GtkAnchorType;

    typedef enum {
	GTK_IM_STATUS_NOTHING,
	GTK_IM_STATUS_CALLBACK,
	GTK_IM_STATUS_NONE
    } GtkIMStatusStyle;

#if __LSB_VERSION__ >= 40
    typedef enum {
	GTK_PACK_DIRECTION_LTR,
	GTK_PACK_DIRECTION_RTL,
	GTK_PACK_DIRECTION_TTB,
	GTK_PACK_DIRECTION_BTT
    } GtkPackDirection;

#endif				/* __LSB_VERSION__ >= 4.0 */

#if __LSB_VERSION__ >= 41
    typedef enum {
	GTK_PAGE_ORIENTATION_PORTRAIT,
	GTK_PAGE_ORIENTATION_LANDSCAPE,
	GTK_PAGE_ORIENTATION_REVERSE_PORTRAIT,
	GTK_PAGE_ORIENTATION_REVERSE_LANDSCAPE
    } GtkPageOrientation;

    typedef enum {
	GTK_PRINT_QUALITY_LOW,
	GTK_PRINT_QUALITY_NORMAL,
	GTK_PRINT_QUALITY_HIGH,
	GTK_PRINT_QUALITY_DRAFT
    } GtkPrintQuality;

    typedef enum {
	GTK_PRINT_DUPLEX_SIMPLEX,
	GTK_PRINT_DUPLEX_HORIZONTAL,
	GTK_PRINT_DUPLEX_VERTICAL
    } GtkPrintDuplex;

    typedef enum {
	GTK_PRINT_PAGES_ALL,
	GTK_PRINT_PAGES_CURRENT,
	GTK_PRINT_PAGES_RANGES,
	GTK_PRINT_PAGES_SELECTION
    } GtkPrintPages;

    typedef enum {
	GTK_PAGE_SET_ALL,
	GTK_PAGE_SET_EVEN,
	GTK_PAGE_SET_ODD
    } GtkPageSet;

    typedef enum {
	GTK_NUMBER_UP_LAYOUT_LEFT_TO_RIGHT_TOP_TO_BOTTOM,
	GTK_NUMBER_UP_LAYOUT_LEFT_TO_RIGHT_BOTTOM_TO_TOP,
	GTK_NUMBER_UP_LAYOUT_RIGHT_TO_LEFT_TOP_TO_BOTTOM,
	GTK_NUMBER_UP_LAYOUT_RIGHT_TO_LEFT_BOTTOM_TO_TOP,
	GTK_NUMBER_UP_LAYOUT_TOP_TO_BOTTOM_LEFT_TO_RIGHT,
	GTK_NUMBER_UP_LAYOUT_TOP_TO_BOTTOM_RIGHT_TO_LEFT,
	GTK_NUMBER_UP_LAYOUT_BOTTOM_TO_TOP_LEFT_TO_RIGHT,
	GTK_NUMBER_UP_LAYOUT_BOTTOM_TO_TOP_RIGHT_TO_LEFT
    } GtkNumberUpLayout;

    typedef enum {
	GTK_UNIT_PIXEL,
	GTK_UNIT_POINTS,
	GTK_UNIT_INCH,
	GTK_UNIT_MM
    } GtkUnit;

    typedef enum {
	GTK_SENSITIVITY_AUTO,
	GTK_SENSITIVITY_ON,
	GTK_SENSITIVITY_OFF
    } GtkSensitivityType;

    typedef enum {
	GTK_TREE_VIEW_GRID_LINES_NONE,
	GTK_TREE_VIEW_GRID_LINES_HORIZONTAL,
	GTK_TREE_VIEW_GRID_LINES_VERTICAL,
	GTK_TREE_VIEW_GRID_LINES_BOTH
    } GtkTreeViewGridLines;

#include <gtk-2.0/gtk/gtk.h>
#endif				/* __LSB_VERSION__ >= 4.1 */

#ifdef __cplusplus
}
#endif
#endif				/* protection */
#endif				/* LSB version */
